/**************************************************************************
**  (c) Copyright 2012, Andromeda Technology & Automation
***************************************************************************
** MODULE INFORMATION *
***********************
**      FILE NAME      : host.h
**      SYSTEM NAME    : Network and socket classes
**      VERSION NUMBER : 0.1
**
**  DESCRIPTION      :  Host class definition
**
**  EXPORTED OBJECTS : class Host
**  LOCAL    OBJECTS : 
**  MODULES  USED    :
***************************************************************************
**  ADMINISTRATIVE INFORMATION *
********************************
**      ORIGINAL AUTHOR : Arjen Baart - arjen@andromeda.nl
**      CREATION DATE   : Mar 02, 2012
**      LAST UPDATE     : Mar 05, 2012
**      MODIFICATIONS   : 
**************************************************************************/

#include <list>
#include "inetaddress.h"

/*+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
**  NAME           : Host - A class to find hosts and addresses
**  MEMBERS        : name      : The name of the host (FQDN).
**                   addresses : The IP addresses on which the host can be reached.
**  OPERATORS      : None
**  METHODS        : FindAddress() : Find all network addresses.
**                   FindName()    : Find the name if the address in known.
**
**  DESCRIPTION    : 
**
**
**  RELATIONS      : 
**  SEE ALSO       : getaddrinfo(3), getnameinfo()
**  LAST MODIFIED  : Mar 05, 2012
**+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
*/

class Host
{
   String name;
   std::list<InternetAddress> addresses;

public:

   Host(String hostname)
   {
      name = hostname;
   }

   String FindName();
   std::list<InternetAddress> FindAddress();

};
