/**************************************************************************
**  (c) Copyright 2012, Andromeda Technology & Automation
***************************************************************************
** MODULE INFORMATION *
***********************
**      FILE NAME      : service.h
**      SYSTEM NAME    : Network and socket classes
**      VERSION NUMBER : 0.1
**
**  DESCRIPTION      :  Service class definition
**
**  EXPORTED OBJECTS : class Service
**  LOCAL    OBJECTS : 
**  MODULES  USED    :
***************************************************************************
**  ADMINISTRATIVE INFORMATION *
********************************
**      ORIGINAL AUTHOR : Arjen Baart - arjen@andromeda.nl
**      CREATION DATE   : Mar 02, 2012
**      LAST UPDATE     : Mar 07, 2012
**      MODIFICATIONS   : 
**************************************************************************/

#include <list>
#include <netdb.h>
#include <AXE/String.h>
#include "port.h"

/*+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
**  NAME           : Service - A class to find services and ports
**  MEMBERS        : name      : The name of the service.
**                   ports     : The port numbers on which the service can be reached.
**  OPERATORS      : None
**  METHODS        : FindAddress() : Find all port numbers.
**                   FindName()    : Find the name if the port in known.
**
**  DESCRIPTION    : 
**
**
**  RELATIONS      : 
**  SEE ALSO       : getaddrinfo(3), getnameinfo()
**  LAST MODIFIED  : Mar 07, 2012
**+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
*/

class Service
{
   String name;
   std::list<Port> ports;

public:

   Service(String servname)
   {
      name = servname;
   }

   String FindName();
   std::list<Port> FindAddress();

};
