/**************************************************************************
**  (c) Copyright 2012, Andromeda Technology & Automation
***************************************************************************
** MODULE INFORMATION *
***********************
**      FILE NAME      : iptest.cpp
**      SYSTEM NAME    : Network and socket classes - test routine
**      VERSION NUMBER : 0.1
**
**  DESCRIPTION      :  Internet address classes tests
**
**  EXPORTED OBJECTS : 
**  LOCAL    OBJECTS : 
**  MODULES  USED    :
***************************************************************************
**  ADMINISTRATIVE INFORMATION *
********************************
**      ORIGINAL AUTHOR : Arjen Baart - arjen@andromeda.nl
**      CREATION DATE   : Mar 02, 2012
**      LAST UPDATE     : Mar 05, 2012
**      MODIFICATIONS   : 
**************************************************************************/


#include "host.h"
#include "service.h"
#include "socket.h"


/*=========================================================================
**  NAME           : main
**  SYNOPSIS       :
**  PARAMETERS     :
**  RETURN VALUE   : None
**
**  DESCRIPTION    : 
**
**  VARS USED      :
**  VARS CHANGED   :
**  FUNCTIONS USED :
**  SEE ALSO       :
**  LAST MODIFIED  : Mar 05, 2012
**=========================================================================
*/

int main()
{
   std::cout << "IP address test\n";

   InternetAddress ip("1:0:0:a::1");

   std::cout << String(ip) << "\n";

   std::cout << "Finding www.noortict.nl\n";
   Host server(String("www.noortict.nl"));
   std::list<InternetAddress> iplist = server.FindAddress();
   std::list<InternetAddress>::iterator ipaddress;
   for (ipaddress = iplist.begin(); ipaddress != iplist.end(); ipaddress++)
   {
      std::cout << "  IP address " << String(*ipaddress) << "\n";
   }

   Service srv("http");
   std::list<Port> portlist = srv.FindAddress();
   std::list<Port>::iterator port;
   for (port = portlist.begin(); port != portlist.end(); port++)
   {
      std::cout << "  Port " << port->get_port() << ", socket type " << port->get_sockettype() << "\n";
   }

   IPSocketAddress serveraddress(iplist.front(), portlist.front());
   StreamSocket s;

   std::cout << "Connection result = " << s.Connect(serveraddress) << "\n";
   s.Write("GET / HTTP/1.1\n", 15);
   s.Write("Host: www.noortict.nl\n\n", 23);

   char buf[1000];
   int  len;
   do
   {
      len = s.Read(buf, 1000);
      buf[len] = '\0';
      std::cout << "LEN = " << len << "\n" << buf << "\n";
   }
   while (len > 0);

}

