/**************************************************************************
**  (c) Copyright 2012, Andromeda Technology & Automation
***************************************************************************
** MODULE INFORMATION *
***********************
**      FILE NAME      : revd.cpp
**      SYSTEM NAME    : Network and socket classes - test routine
**      VERSION NUMBER : 0.1
**
**  DESCRIPTION      :  Server socket test.
**
**  EXPORTED OBJECTS : 
**  LOCAL    OBJECTS : 
**  MODULES  USED    :
***************************************************************************
**  ADMINISTRATIVE INFORMATION *
********************************
**      ORIGINAL AUTHOR : Arjen Baart - arjen@andromeda.nl
**      CREATION DATE   : Mar 02, 2012
**      LAST UPDATE     : Mar 09, 2012
**      MODIFICATIONS   : 
**************************************************************************/


#include "socket.h"


/*=========================================================================
**  NAME           : main
**  SYNOPSIS       :
**  PARAMETERS     :
**  RETURN VALUE   : None
**
**  DESCRIPTION    : 
**
**  VARS USED      :
**  VARS CHANGED   :
**  FUNCTIONS USED :
**  SEE ALSO       :
**  LAST MODIFIED  : Mar 09, 2012
**=========================================================================
*/

int main()
{
   std::cout << "Server socket test\n";

   InternetAddress ip(in6addr_any);
   Port            prt(2112);
   IPSocketAddress sa(ip, prt);

   std::cout << "Listening on IP address " << String(ip) << "\n";

   StreamSocket s;
   s.Listen(sa);

   while (true)
   {
      char buf[1000];
      int  len;

      StreamSocket client = s.Accept();
      std::cout << "Socket connected.\n";

      do
      {
         char reverse[1000];

         buf[0] = '\0';
         len = client.Read(buf, 1000);
         buf[len] = '\0';
         std::cout << "\nLEN = " << len << "\n" << buf << "\n";
         for (int i = 0; i < len; i++)
         {
            reverse[i] = buf[len-i-1];
         }
         client.Write(reverse, len);
      }
      while (len > 0);
      client.Close();
   }
}

